------------------------------------------------------------------------------------------
--Engine Variables------------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))

SN.DB = {
	profile = {
		["debug"] = {
			["enable"] = false,
		},
		["cooldown"] = {
			["castannounce"] = true,
			["show"] = "always",
			["raid"] = true,
			["width"] = 300,
			["height"] = 20,
			["fontsize"] = 14,
			["font"] = "SNFont",
			["texture"] = "SNMin",
		},
		["classSelect"] = {
			["default"] = "DEATHKNIGHT",
		},
		["classResources"] = {
			["enable"] = true,
		},
		["dispel"] = {
			["enable"] = false,
		},
		["threat"] = {
			["enable"] = false,
			["spells"] = {
			----------------------
			--Rogue Threat Dumps--
			----------------------
			-- Tricks of the Trade
				[57934] = {
					id = 57934,
					class = "ROGUE",
					order = 1,
					msg = true,
					enable = true,
				},
			--Vanish
				[1856] = {
					id = 1856,
					class = "ROGUE",
					order = 2,
					msg = false,
					enable = true,
				},
			-----------------------
			--Hunter Threat Dumps--
			-----------------------
			--Feign Death
				[5384] = {
					id = 5384,
					class = "HUNTER",
					order = 2,
					msg = false,
					enable = true,
				},
			--Misdirection
				[34774] = {
					id = 34774,
					class = "HUNTER",
					order = 1,
					msg = true,
					enable = true,
				},
			---------------------
			--Mage Threat Dumps--
			---------------------
			--Ice Block
				[45438] = {
					id = 45438,
					class = "MAGE",
					order = 2,
					msg = false,
					enable = true,
				},
			--Mirror Image
				[55342] = {
					id = 55342,
					class = "MAGE",
					order = 1,
					msg = false,
					enable = true,
				},
			-----------------------
			--Priest Threat Dumps--
			-----------------------
			--Fade
				[586] = {
					id = 586,
					class = "PRIEST",
					order = 1,
					msg = false,
					enable = true,
				},
			-----------------------
			--Shaman Threat Dumps--
			-----------------------
			--Wind Shear
				[57994] = {
					id = 57994,
					class = "SHAMAN",
					order = 1,
					msg = false,
					enable = true,
				},
			------------------------
			--Paladin Threat Dumps--
			------------------------
			--Divine Shield
				[642] = {
					id = 642,
					class = "PALADIN",
					order = 1,
					msg = false,
					enable = true,
				},
			},
		},
		["debuffs"] = {
			["enable"] = true,
			["width"] = 300,
			["height"] = 20,
			["fontsize"] = 14,
			["font"] = "SNFont",
			["texture"] = "SNMin",
		},
		["frames"] = {
			["lock"] = true,
			["threat"] = { "CENTER", nil, "CENTER", 0, 50 },
			["debuffs"] = { "CENTER", nil, "CENTER", 175, -250 },
			["elvdebuffs"] = { "CENTER", nil, "CENTER", 0, -250	},
			["cooldowns"] = { "BOTTOMRIGHT", nil, "BOTTOMRIGHT", -50, 0 },
			["elvcooldowns"] = { "TOPLEFT", nil, "TOPLEFT", 4, 0 },
			["dispel"] = { "CENTER", nil, "CENTER", 0, 0 },
			["power"] = { "CENTER", nil, "CENTER", 0, 50 },
			["cc"] = { "CENTER", nil, "CENTER", 0, 0 },
			["classpower"] = { "CENTER", nil, "CENTER", 0, -175 },
		},
		["powerbar"] = {
			["tickenable"] = false,
			["enable"] = true,
			["width"] = 267,
			["height"] = 24,
			["fontsize"] = 16,
			["font"] = "SNFont",
			["texture"] = "SNMin",
			["hunter"] = {
				{	--Beast Mastery
					{ true, "Kill Command", true, false, {1,1,1,1}, 0 },
					{ false, "Glaive Toss", true, false, {1,1,1,1}, 0 },
				},
				{	--Marksman
					{ true, "Chimera Shot", true, false, {1,1,1,1}, 0 },
					{ false, "Aimed Shot", true, false, {1,1,1,1}, 0 },
				},
				{	--Survival
					{ true, "Explosive Shot", true, false, {1,1,1,1}, 0 },
					{ false, "Black Arrow", true, false, {1,1,1,1}, 0 },
				},
			},
			["rogue"] = {
				{	--Assassination
					{ true, "Mutilate", true, false, {1,1,1,1}, 0 },
					{ false, "Dispatch", true, false, {1,1,1,1}, 0 },
				},
				{	--Combat
					{ true, "Sinister Strike", true, false, {1,1,1,1}, 0 },
					{ false, "Eviscerate", true, false, {1,1,1,1}, 0 },
				},
				{	--Subtlety
					{ true, "Backstab", true, false, {1,1,1,1}, 0 },
					{ false, "Eviscerate", true, false, {1,1,1,1}, 0 },
				},
			},
			["druid"] = {
				{	--Feral
					{ true, "Shred", true, false, {1,1,1,1}, 0 },
					{ false, "Mangle", true, false, {1,1,1,1}, 0 },
				},
				{	--Guardian
					{ true, "Savage Defense", true, false, {1,1,1,1}, 0 },
					{ false, "Frenzied Regeneration", true, false, {1,1,1,1}, 0 },
				},
			},
			["warrior"] = {
				{	--Arms
					{ true, "Slam", true, false, {1,1,1,1}, 0 },
					{ false, "Execute", true, false, {1,1,1,1}, 0 },
				},
				{	--Fury
					{ true, "Heroic Strike", true, false, {1,1,1,1}, 0 },
					{ false, "Execute", true, false, {1,1,1,1}, 0 },
				},
				{	--Prot
					{ true, "Shield Block", true, false, {1,1,1,1}, 0 },
					{ false, "Shield Barrier", true, false, {1,1,1,1}, 0 },
				},
			},
			["deathknight"] = {
				{	--Blood
					{ true, "Rune Strike", true, false, {1,1,1,1}, 0 },
					{ false, "Dancing Rune Weapon", true, false, {1,1,1,1}, 0 },
				},
				{	--Frost
					{ true, "Frost Strike", true, false, {1,1,1,1}, 0 },
					{ false, "Death Coil", true, false, {1,1,1,1}, 0 },
				},
				{	--Unholy
					{ true, "Death Coil", true, false, {1,1,1,1}, 0 },
					{ false, "Summon Gargoyle", true, false, {1,1,1,1}, 0 },
				},		
			},
		},
		["cooldowns"] = {
			[20484] = { -- Rebirth
	id = 20484,
	CD = 600,
	class = "DRUID",
	enable = true,
	},
			[29166] = { -- Innervate
	id = 29166,
	CD = 180,
	class = "DRUID",
	enable = true,
	},
			[132158] = { -- Nature's Swiftness
	id = 132158,
	CD = 60,
	class = "DRUID",
	enable = true,
	},
			[61336] = { -- Survival Instincts
	id = 61336,
	CD = 180,
	class = "DRUID",
	enable = true,
	},
			[22812] = { -- Barkskin
	id = 22812,
	CD = 60,
	class = "DRUID",
	enable = true,
	},
			[33831] = { -- Force of Nature
	id = 33831,
	CD = 60,
	class = "DRUID",
	enable = true,
	},
			[48505] = { -- Starfall
	id = 48505,
	CD = 90,
	class = "DRUID",
	enable = true,
	},
			[50334] = { -- Beserk
	id = 50334,
	CD = 180,
	class = "DRUID",
	enable = true,
	},
			[33891] = { -- Tree of Life
	id = 33891,
	CD = 180,
	class = "DRUID",
	enable = true,
	},
			[740] = { -- Tranquility
	id = 740,
	CD = 480,
	class = "DRUID",
	enable = true,
	},
			[77761] = { -- Stampeding Roar
	id = 77761,
	CD = 120,
	class = "DRUID",
	enable = true,
	},
			[102342] = { -- Ironbark
	id = 102342,
	CD = 120,
	class = "DRUID",
	enable = true,
	},
			[19263] = { -- Deterrence
	id = 19263,
	CD = 120,
	class = "HUNTER",
	enable = true,
	},
			[23989] = { -- Readiness
	id = 23989,
	CD = 300,
	class = "HUNTER",
	enable = true,
	},
			[19574] = { -- Bestial Wrath
	id = 19574,
	CD = 60,
	class = "HUNTER",
	enable = true,
	},
			[3045]  = { -- Rapid Fire
	id = 3045,
	CD = 180,
	class = "HUNTER",
	enable = true,
	},
			[126393] = { -- Eternal Guardian
	id = 126393,
	CD = 600,
	class = "HUNTER",
	enable = true,
	},
			[90355] = { -- Ancient Hysteria
	id = 90355,
	CD = 360,
	class = "HUNTER",
	enable = true,
	},
			[45438] = { -- Ice Block
	id = 45438,
	CD = 300,
	class = "MAGE",
	enable = true,
	},
			[66] = { -- Invisibility
	id = 66,
	CD = 300,
	class = "MAGE",
	enable = true,
	},
			[12472] = { -- Icy Veins
	id = 12472,
	CD = 180,
	class = "MAGE",
	enable = true,
	},
			[11958] = { -- Cold Snap
	id = 11958,
	CD = 180,
	class = "MAGE",
	enable = true,
	},
			[12043] = { -- Presence of Mind
	id = 12043,
	CD = 90,
	class = "MAGE",
	enable = true,
	},
			[12042] = { -- Arcane Power
	id = 12042,
	CD = 90,
	class = "MAGE",
	enable = true,
	},
			[80353] = { -- Time Warp
	id = 80353,
	CD = 300,
	class = "MAGE",
	enable = true,
	},
			[633] = { -- Lay on Hands
	id = 633,
	CD = 600,
	class = "PALADIN",
	enable = true,
	},
			[1022] = { -- Hand of Protection
	id = 1022,
	CD = 300,
	class = "PALADIN",
	enable = true,
	},
			[498] = { -- Divine Protection
	id = 498,
	CD = 60,
	class = "PALADIN",
	enable = true,
	},
			[642] = { -- Divine Shield
	id = 642,
	CD = 300,
	class = "PALADIN",
	enable = true,
	},
			[1038] = { -- Hand of Salvation
	id = 1038,
	CD = 120,
	class = "PALADIN",
	enable = true,
	},
			[6940] = { -- Hand of Sacrifice
	id = 6940,
	CD = 120,
	class = "PALADIN",
	enable = true,
	},
			[31821] = { -- Devotion Aura
	id = 31821,
	CD = 180,
	class = "PALADIN",
	enable = true,
	},
			[31850] = { -- Ardent Defender
	id = 31850,
	CD = 180,
	class = "PALADIN",
	enable = true,
	},
			[31884] = { -- Avenging Wrath
	id = 31884,
	CD = 180,
	class = "PALADIN",
	enable = true,
	},
			[853] = { -- Hammer of Justice
	id = 853,
	CD = 60,
	class = "PALADIN",
	enable = true,
	},
			[86698] = { -- Guardian of Ancient Kings (Ret)
	id = 86698,
	CD = 300,
	class = "PALADIN",
	enable = true,
	}, 
			[86669] = {  -- Guardian of Ancient Kings (Holy)
	id = 86669,
	CD = 300,
	class = "PALADIN",
	enable = true,
	},
			[86659] = { -- Guardian of Ancient Kings (Prot)
	id = 86659,
	CD = 180,
	class = "PALADIN",
	enable = true,
	},
			[105809] = { -- Holy Avenger
	id = 105809,
	CD = 120,
	class = "PALADIN",
	enable = true,
	},
			[6346]  = { -- Fear Ward
	id = 6346,
	CD = 180,
	class = "PRIEST",
	enable = true,
	},
			[64901] = { -- Hymn of Hope
	id = 64901,
	CD = 360,
	class = "PRIEST",
	enable = true,
	},
			[34433] = { -- Shadowfiend
	id = 34433,
	CD = 180,
	class = "PRIEST",
	enable = true,
	},
			[64843] = { -- Divine Hymn
	id = 64843,
	CD = 180,
	class = "PRIEST",
	enable = true,
	},
			[10060] = { -- Power Infusion
	id = 10060,
	CD = 120,
	class = "PRIEST",
	enable = true,
	},
			[33206] = { -- Pain Suppression
	id = 33206,
	CD = 180,
	class = "PRIEST",
	enable = true,
	},
			[62618] = { -- Power Word: Barrier
	id = 62618,
	CD = 180,
	class = "PRIEST",
	enable = true,
	},
			[724] = { -- Lightwell
	id = 724,
	CD = 180,
	class = "PRIEST",
	enable = true,
	},
			[47788] = { -- Guardian Spirit
	id = 47788,
	CD = 180,
	class = "PRIEST",
	enable = true,
	},
			[47585] = { -- Dispersion
	id = 47585,
	CD = 120,
	class = "PRIEST",
	enable = true,
	},
			[19236] = { -- Desperate Prayer
	id = 19236,
	CD = 120,
	class = "PRIEST",
	enable = true,
	},
			[64044] = { -- Psychic Horror
	id = 64044,
	CD = 120,
	class = "PRIEST",
	enable = true,
	},
			[73325] = { -- Leap of Faith
	id = 73325,
	CD = 90,
	class = "PRIEST",
	enable = true,
	},
			[15286] = { -- Vampiric Embrace
	id = 15286,
	CD = 180,
	class = "PRIEST",
	enable = true,
	},
			[109964] = { -- Spirit Shell
	id = 109964,
	CD = 60,
	class = "PRIEST",
	enable = true,
	},
			[5277] = { -- Evasion
	id = 5277,
	CD = 180,
	class = "ROGUE",
	enable = true,
	}, 
			[1856] = { -- Vanish
	id = 1856,
	CD = 180,
	class = "ROGUE",
	enable = true,
	},
			[2094] = { -- Blind
	id = 2094,
	CD = 180,
	class = "ROGUE",
	enable = true,
	},
			[31224] = { -- Cloak of Shadows
	id = 31224,
	CD = 120,
	class = "ROGUE",
	enable = true,
	},
			[14185] = { -- Preparation
	id = 14185,
	CD = 300,
	class = "ROGUE",
	enable = true,
	},
			[79140] = { -- Vendetta
	id = 79140,
	CD = 120,
	class = "ROGUE",
	enable = true,
	},
			[13750] = { -- Adrenaline Rush
	id = 13750,
	CD = 180,
	class = "ROGUE",
	enable = true,
	},
			[51690] = { -- Killing Spree
	id = 51690,
	CD = 120,
	class = "ROGUE",
	enable = true,
	},
			[51713] = { -- Shadow Dance
	id = 51713,
	CD = 60,
	class = "ROGUE",
	enable = true,
	},
			[76577] = { -- Smoke Bomb
	id = 76577,
	CD = 180,
	class = "ROGUE",
	enable = true,
	},
			[20608] = { -- Reincarnation
	id = 20608,
	CD = 1800,
	class = "SHAMAN",
	enable = true,
	},
			[2062] = { -- Earth Elemental Totem
	id = 2062,
	CD = 300,
	class = "SHAMAN",
	enable = true,
	},
			[2894] = { -- Fire Elemental Totem
	id = 2894,
	CD = 300,
	class = "SHAMAN",
	enable = true,
	},
			[2825] = { -- Bloodlust
	id = 2825,
	CD = 300,
	class = "SHAMAN",
	enable = true,
	},
			[32182] = { --Heroism
	id = 32182,
	CD = 300,
	class = "SHAMAN",
	enable = true,
	},
			[16188] = { -- Ancestral Swiftness
	id = 16188,
	CD = 60,
	class = "SHAMAN",
	enable = true,
	},
			[16190] = { -- Mana Tide Totem
	id = 16190,
	CD = 180,
	class = "SHAMAN",
	enable = true,
	},
			[556] = { -- Astral Recall
	id = 556,
	CD = 900,
	class = "SHAMAN",
	enable = true,
	},
			[16166] = { -- Elemental Mastery
	id = 16166,
	CD = 120,
	class = "SHAMAN",
	enable = true,
	},
			[79206] = { -- Spiritwalker's Grace
	id = 79206,
	CD = 120,
	class = "SHAMAN",
	enable = true,
	},
			[51533] = { -- Feral Spirit
	id = 51553,
	CD = 120,
	class = "SHAMAN",
	enable = true,
	},
			[98008] = { -- Spirit Link Totem
	id = 98008,
	CD = 180,
	class = "SHAMAN",
	enable = true,
	},
			[120668] = { -- Stormlash Totem
	id = 120668,
	CD = 300,
	class = "SHAMAN",
	enable = true,
	},
			[108280] = { -- Healing Tide Totem
	id = 108280,
	CD = 180,
	class = "SHAMAN",
	enable = true,
	},
			[108281] = { -- Ancestral Guidance
	id = 108281,
	CD = 120,
	class = "SHAMAN",
	enable = true,
	},
			[108271] = { -- Astral Shift
	id = 108271,
	CD = 120,
	class = "SHAMAN",
	enable = true,
	},
			[114049] = { -- Ancendance
	id = 114049,
	CD = 180,
	class = "SHAMAN",
	enable = true,
	},
			[20707] = { -- Soulstone Ressurrection
	id = 20707,
	CD = 600,
	class = "WARLOCK",
	enable = true,
	},
			[698] = { -- Ritual of Summoning
	id = 698,
	CD = 120,
	class = "WARLOCK",
	enable = true,
	},
			[1122] = { -- Summon Infernal
	id = 1122,
	CD = 600,
	class = "WARLOCK",
	enable = true,
	},
			[18540] = { -- Summon Doomguard
	id = 18540,
	CD = 600,
	class = "WARLOCK",
	enable = true,
	},
			[29858] = { -- Soulshatter
	id = 29858,
	CD = 120,
	class = "WARLOCK",
	enable = true,
	},
			[29893] = { -- Create Soulwell
	id = 29893,
	CD = 120,
	class = "WARLOCK",
	enable = true,
	},
			[1719] = { -- Recklessness
	id = 1719,
	CD = 300,
	class = "WARRIOR",
	enable = true,
	},
			[871] = { -- Shield Wall
	id = 871,
	CD = 300,
	class = "WARRIOR",
	enable = true,
	},
			[64382] = { -- Shattering Throw
	id = 64382,
	CD = 300,
	class = "WARRIOR",
	enable = true,
	},
			[55694] = { -- Enraged Regeneration
	id = 55694,
	CD = 60,
	class = "WARRIOR",
	enable = true,
	},
			[12975] = { -- Last Stand
	id = 12975,
	CD = 180,
	class = "WARRIOR",
	enable = true,
	},
			[46924] = { -- Bladestorm
	id = 46924,
	CD = 90,
	class = "WARRIOR",
	enable = true,
	},
			[97462] = { -- Rallying Cry
	id = 97462,
	CD = 180,
	class = "WARRIOR",
	enable = true,
	},
			[114030] = { -- Vigilance
	id = 114030,
	CD = 120,
	class = "WARRIOR",
	enable = true,
	},
			[114203] = { -- Demoralizing Banner
	id = 114203,
	CD = 180,
	class = "WARRIOR",
	enable = true,
	},
			[114207] = { -- Skull Banner
	id = 114207,
	CD = 180,
	class = "WARRIOR",
	enable = true,
	},
			[114192] = { -- Mocking Banner
	id = 114192,
	CD = 180,
	class = "WARRIOR",
	enable = true,
	},
			[47476] = { -- Strangulate
	id = 47476,
	CD = 120,
	class = "DEATHKNIGHT",
	enable = true,
	},
			[48792] = { -- Icebound Fortitude
	id = 48792,
	CD = 180,
	class = "DEATHKNIGHT",
	enable = true,
	},
			[61999] = { -- Raide Ally
	id = 61999,
	CD = 600,
	class = "DEATHKNIGHT",
	enable = true,
	},
			[42650] = { -- Army of the Dead
	id = 42650,
	CD = 600,
	class = "DEATHKNIGHT",
	enable = true,
	},
			[55233] = { -- Vampiric Blood
	id = 55233,
	CD = 60,
	class = "DEATHKNIGHT",
	enable = true,
	},
			[49028] = { -- Dancing Rune Weapon
	id = 49028,
	CD = 90,
	class = "DEATHKNIGHT",
	enable = true,
	},
			[49039] = { -- Lichborne
	id = 49039,
	CD = 120,
	class = "DEATHKNIGHT",
	enable = true,
	},
			[49016] = { -- Unholy Frenzy
	id = 49016,
	CD = 180,
	class = "DEATHKNIGHT",
	enable = true,
	},
			[49206] = { -- Summon Gargoyle
	id = 49206,
	CD = 180,
	class = "DEATHKNIGHT",
	enable = true,
	},
			[46584] = { -- Raise Dead
	id = 46584,
	CD = 120,
	class = "DEATHKNIGHT",
	enable = true,
	},
			[51052] = { -- Anti-Magic Zone
	id = 51052,
	CD = 120,
	class = "DEATHKNIGHT",
	enable = true,
	},
			[47568] = { -- Empower Rune Weapon
	id = 47568,
	CD = 300,
	class = "DEATHKNIGHT",
	enable = true,
	},
			[48743] = { -- Death Pact
	id = 48743,
	CD = 120,
	class = "DEATHKNIGHT",
	enable = true,
	},
			[115213] = { -- Avert Harm
	id = 115213,
	CD = 180,
	class = "MONK",
	enable = true,
	},
			[115176] = { -- Zen Meditation
	id = 115176,
	CD = 180,
	class = "MONK",
	enable = true,
	},
			[122278] = { -- Dampen Harm
	id = 122278,
	CD = 90,
	class = "MONK",
	enable = true,
	},
			[115310] = { -- Revival
	id = 115310,
	CD = 180,
	class = "MONK",
	enable = true,
	},
			[116849] = { -- Life Cocoon
	id = 116849,
	CD = 120,
	class = "MONK",
	enable = true,
	},
			[115203] = { -- Fortifying Brew
	id = 115203,
	CD = 180,
	class = "MONK",
	enable = true,
	},
			[122470] = { -- Touch of Karma
	id = 122470,
	CD = 90,
	class = "MONK",
	enable = true,
	},
		},
	},
}

